/* file name  : control/SocketInputSource.java
 * authors    : Guillaume Arnaud
 * created    : mar 27 avr 2004 18:36:15 CEST
 * copyright  : 
 *
 * modifications:
 *
 */

package control;

import org.xml.sax.InputSource;

import java.io.BufferedReader;
import java.io.PrintWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import java.net.Socket;
import java.net.ServerSocket;
import java.net.InetSocketAddress;
import java.net.SocketAddress;

import java.util.Random;
/** 
 * 
 * 
 * @author Guillaume Arnaud
 * @version 1.2
 */
public class SocketInputSource implements Runnable{
    
    static final String HOSTPAVOT="localhost";
    static  int PORTPAVOT=3000;
    
    boolean header=false;
    boolean ready=false;
    
    String hosttracer;
    int porttracer;
    String answer;

    char EOF = (char)0x00;
    /** 
     * 
     */
    ServerSocket serverSocketPavot;
    Socket socketPavotIn;
 //   Socket socketPavotOut;
    Socket socketTracer;
    BufferedReader tracerReader;
    BufferedReader pavotInReader;
 //   BufferedReader pavotOutReader;
    PrintWriter tracerWriter;
    PrintWriter pavotInWriter;
 //    PrintWriter pavotOutWriter;
    int portLocal;
    
    public SocketInputSource(String host, int port) throws Exception {
        super();
        hosttracer=host;
        porttracer=port;
        
        Random rand=new Random();
        portLocal=rand.nextInt();
        while(portLocal>9000 || portLocal<0) {portLocal=rand.nextInt();}
        System.out.println(""+portLocal);
        serverSocketPavot=new ServerSocket(portLocal);
    }

    public void initialisation() throws Exception {
        //System.out.println("[SocketInputSource] accepted?");
        //socketPavotIn.connect(serverSocketPavot.getLocalSocketAddress());
        //socketPavotIn.bind(new InetSocketAddress("localhost",portLocal));
        //socketPavotIn.connect(new InetSocketAddress("localhost",portLocal));
        
        socketPavotIn=serverSocketPavot.accept();
        System.out.println("[SocketInputSource] accepted");
        PORTPAVOT=serverSocketPavot.getLocalPort();
        System.out.println("[SocketInputSource] connection on port="+PORTPAVOT);

       // socketPavotOut=new Socket();
       // socketPavotOut.connect(serverSocketPavot.getLocalSocketAddress());

        socketTracer=new Socket();
        socketTracer.connect(new InetSocketAddress(hosttracer, porttracer));
        

        tracerReader= new BufferedReader( new InputStreamReader(socketTracer.getInputStream()), 10);
        //pavotInReader= new BufferedReader( new InputStreamReader(socketPavotIn.getInputStream()));
      //  pavotOutReader= new BufferedReader( new InputStreamReader(socketPavotOut.getInputStream()));
        
        tracerWriter= new PrintWriter( new OutputStreamWriter(socketTracer.getOutputStream())); 
        pavotInWriter= new PrintWriter( new OutputStreamWriter(socketPavotIn.getOutputStream())); 
      //  pavotOutWriter= new PrintWriter( new OutputStreamWriter(socketPavotOut.getOutputStream())); 
        
       // this.setByteStream(socketPavotIn.getInputStream());
      //  socketPavotIn.setTcpNoDelay(true);
      //  socketTracer.setTcpNoDelay(true);
    }

    /** 
     * 
     */
    public void startReading() throws Exception {
        while(true){
            System.out.println("[SocketInputSource] waiting for new line..."+tracerReader.ready());
//            while(!tracerReader.ready()) {tracerWriter.println("SPACE");}
            String str=new String(tracerReader.readLine());
            System.out.println("[SocketInputSource] reading:"+str);
            pavotInWriter.println(str+"\r");
           // pavotInWriter.write(tracerReader.read());
            //System.out.println("[SocketInputSource] pavotOutReader="+pavotOutReader.readLine());
            if(str.matches("<breakpoint.*")||str.matches("</solution>")) {
                System.out.println("[SocketInputSource] "+ str +" waiting for GO");
                pavotInWriter.flush();

                int i=0;
                while(!ready){pavotInWriter.println(" \r");i++;}
                ready=false;
                pavotInWriter.flush();
                System.out.println("[SocketInputSource] blank filled="+i);
                str=answer;
                answer="";
                //str=pavotInReader.readLine();
                //System.out.println("[SocketInputSource] received="+str);
              
                if(str.matches("GO.*")) {
                  System.out.println("[SocketInputSource] "+ str +" : GO");
                }
                else
                    System.out.println("[SocketInputSource] "+ str +" : NO GO");
                tracerWriter.println("GO");
                tracerWriter.flush();
                tracerWriter.flush();
                tracerWriter.flush();
            }
            else if(str.matches("</gentra4cp>.*")) {
                pavotInWriter.flush();
                break;
             }
         }
    }
    
    public void writeToTracer(String str){
        ready=true;
//        pavotInWriter.println(str);
        answer=str;
    }

    public void flush(){
     //   pavotInWriter.flush();
    }

    public void run(){
        try{
            System.out.println("[SocketInputSource] Initialisation");
            this.initialisation();
            System.out.println("[SocketInputSource] Start reading");
            this.startReading();   
        }
        catch(Exception exc) {System.out.println("[SocketInputSource]  can't startReading");}
    }

    public InetSocketAddress getAddress(){
        return (InetSocketAddress)serverSocketPavot.getLocalSocketAddress();
        //return new InetSocketAddress("localhost",portLocal);
    }
        
}
