/*
 *  $Id: UIOneQuery.java, v0.0 2003/10/14$
 */

package gui;

import javax.swing.JCheckBox;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JPanel;
import javax.swing.JComponent;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.JScrollPane;
import java.awt.Font;
import java.util.Vector;
import java.util.Enumeration;
import java.awt.event.*;
import java.awt.*;

public class UIOneQuery extends JPanel implements ItemListener, ActionListener {
	JCheckBox checkBox;
	JCheckBox filterBox=new JCheckBox("filters:",false);
//	Vector filters=new Vector();
	Vector filtersTextField=new Vector();
	int nbFilter=1;
	JButton plusButton=new JButton("+");
	JButton moinsButton=new JButton("-");
	UIManager parent;
	JScrollPane filterScroll=new JScrollPane(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	Box filterContainer=new Box(BoxLayout.Y_AXIS);
	Box fillBox = new Box(BoxLayout.Y_AXIS);
	GridLayout filterLayout=new GridLayout(1,1);
	GridBagLayout queryLayout=new GridBagLayout();
	GridBagConstraints queryLayoutConstraint=new GridBagConstraints();
	boolean filterable=false;

	/**
	 * Constructor.
	 */
	public  UIOneQuery(String s) {
		init(s,200,20);
	}
	
	public  UIOneQuery(String s, boolean b) {
		filterable=b;
		init(s,200,20);
	}
	
	public  UIOneQuery(String s, UIManager p) {
		init(s,200,20);
		parent=p;
	}

	public  UIOneQuery(String s, UIManager p, boolean b,int w, int h) {
		filterable=b;
		parent=p;
		init(s,w,h);
	}
	
	/**
	 * Initializes.
	 */
	public void init(String s, int w, int h){
		this.setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
		this.setPreferredSize(new Dimension(w,h));
		//this.setMaximumSize(new Dimension(w,h));
		
		checkBox=new JCheckBox(s,false);
	//	checkBox.setFont(new Font("disable",Font.HANGING_BASELINE,12));
		checkBox.setPreferredSize(new Dimension((int)w/3,h));
		checkBox.setMaximumSize(new Dimension((int)w/3,h));
		checkBox.setMinimumSize(new Dimension((int)w/3,h));
		checkBox.addItemListener(this);		
		checkBox.setVisible(true);
		checkBox.setOpaque(true);
		
/*		queryLayoutConstraint.fill=GridBagConstraints.NONE;
		queryLayoutConstraint.anchor=GridBagConstraints.NORTHWEST;
		queryLayout.setConstraints(checkBox,queryLayoutConstraint);*/
		this.add(checkBox);
		this.add(Box.createHorizontalGlue());

		if(filterable){
			// filter check box
		/*	queryLayoutConstraint.anchor=GridBagConstraints.NORTHWEST;
			queryLayout.setConstraints(filterBox,queryLayoutConstraint);*/
			filterBox.addItemListener(this);
			this.add(filterBox);
			
			//filter text fields
			this.addFilter();
			//filterContainer.setLayout(new GridLayout(2,1));
			filterContainer.setSize(new Dimension(w,500));
			filterContainer.setPreferredSize(new Dimension(w,500));
		//	filterContainer.setMaximumSize(new Dimension(w,5*h));
			filterContainer.setMinimumSize(new Dimension(w,500));
			/*queryLayoutConstraint.fill=GridBagConstraints.CENTER;
			queryLayoutConstraint.anchor=GridBagConstraints.NORTHWEST;
			queryLayout.setConstraints(filterContainer,queryLayoutConstraint);*/
	//		JComponent filledContainer=new JComponent();
			fillBox.setSize(new Dimension (w,475));
			fillBox.setPreferredSize(new Dimension(w,475));
			fillBox.setMaximumSize(new Dimension (w,475));
			fillBox.setMinimumSize(new Dimension (w,475));
			filterContainer.add(fillBox);
			filterScroll.setViewportView(filterContainer);
			this.add(filterScroll);

			// plus and minus buttons
			plusButton.setSize(30,30);
			moinsButton.setSize(30,30);		
			/*queryLayoutConstraint.fill=GridBagConstraints.NONE;
			queryLayoutConstraint.anchor=GridBagConstraints.NORTHWEST;*/
			plusButton.addActionListener(this);
			//queryLayout.setConstraints(plusButton,queryLayoutConstraint);
			this.add(plusButton);
			moinsButton.addActionListener(this);
			//queryLayout.setConstraints(moinsButton,queryLayoutConstraint);
			this.add(moinsButton);
		}

		this.setVisible(true);

	}

	/**
	 * Is selected?.
	 */
	public boolean isSelected(){ return checkBox.isSelected();}


	/**
	 * Has filters?.
	 */
	public boolean hasFilters(){ return filterable&&filterBox.isSelected()&&(((JTextField)filtersTextField.lastElement()).getText()!="");}
	
	/**
	 * Manages item events.
	 */
	public void itemStateChanged(ItemEvent e){
	
		if(e.getItemSelectable()==checkBox){
			if(e.getStateChange()==ItemEvent.DESELECTED){
				this.removeAllFilters();
				filterBox.setSelected(false);
			}
			else{
			}
		}
		else if(filterable && e.getItemSelectable()==filterBox){
			if(e.getStateChange()==ItemEvent.DESELECTED){
				this.removeAllFilters();
			}			
			else{
				checkBox.setSelected(true);
			}

		}
 	}
	
	/**
	 * Manages action events.
	 */
	public void actionPerformed(ActionEvent e){
		
		if(filterable && e.getSource()==plusButton && filterBox.isSelected()){
			if(nbFilter==0){
				nbFilter++;
			}
			else this.addFilter();
		}
		else if(filterable && e.getSource()==moinsButton && filterBox.isSelected()){
			if(nbFilter>1){	
				nbFilter--;
				filterContainer.remove((Container)filtersTextField.lastElement());
				filterContainer.validate();
				filtersTextField.remove((Container)filtersTextField.lastElement());
				filterLayout.setRows(nbFilter);
				//filterContainer.setLayout(filterLayout);
				if(parent!=null) { parent.refresh(); }
			}
			else if(nbFilter==1){
				this.removeAllFilters();
/*				nbFilter=0;
				((JTextField)filtersTextField.elementAt(0)).setText("");
				if(parent!=null) { parent.refresh();}*/
			}
		}
	}

	/**
	 * Remove filters.
	 */
	private void removeAllFilters(){
		if(filterable){
			nbFilter=0;
			filtersTextField.removeAllElements();
			filterContainer.removeAll();
			filterContainer.validate();
			addFilter();				
			if(parent!=null) { parent.refresh();}
		}
	}
	
	/**
	 * Adds a filter.
	 */
	private void addFilter(){
		if(filterable){
			final JTextField newTextField=new JTextField("",15);
			newTextField.setSize(new Dimension(100,20));
			newTextField.setPreferredSize(new Dimension(500,20));
			newTextField.setMinimumSize(new Dimension(500,20));
			nbFilter++;
			newTextField.setVisible(true);
			newTextField.setOpaque(true);
			filterLayout.setRows(nbFilter);
			//filterContainer.setLayout(filterLayout);
			filterContainer.add(newTextField,filterContainer.getComponentCount()-1);
			filterContainer.validate();
			
	//			this.repaint();			
			if(parent!=null) { parent.refresh(); }
			filtersTextField.addElement(newTextField);
		}
	}
		
	/**
	 * gets filters text field.
	 */
	public Vector getFilters(){
		Vector filters=new Vector();
		if(filterable){
			Enumeration e=filtersTextField.elements();
			
			while(e.hasMoreElements()){
				JTextField jtf=(JTextField)e.nextElement();
				if(jtf.getText()!="")
					filters.addElement(jtf.getText());
			}
		}
		return filters;
	}

	public void setActivate(boolean b) { 
		checkBox.setEnabled(b);
		filterBox.setEnabled(b);
	}
}
