/*
 * $Id: UISolverSelection.java, v0.0 2003/10/14$
 */
package gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import datastruct.*;

import javax.swing.*;

/*
import fr.emn.oadymppac.*;
import fr.emn.oadymppac.propagation.*;
import fr.emn.oadymppac.event.*;
import fr.emn.oadymppac.event.propagation.*;
import fr.emn.oadymppac.helpers.*;
*/

import viewer.ViewerConstants;
import javax.swing.border.EtchedBorder;

public class  UISolverSelection extends JFrame implements ActionListener
{
//	MainManager mainManager;
	JButton ok=new JButton("Ok");
//	JCheckBox clpguisocketBox =new JCheckBox("CLPGUI solver (adapted)");
//	JCheckBox gprologsocketBox =new JCheckBox("GNU Prolog with Codeine tracer");
	JCheckBox fileBox =new JCheckBox("File: ");
	JCheckBox socketBox=new JCheckBox("Socket (host and port must be provided by the solver and already open):");
	JTextField hostField=new JTextField("localhost",10);
	JTextField portField=new JTextField("",10);
	JTextField fileLocationField=new JTextField("",10);
	boolean isfinish=false;

	JLabel headerLabel = new JLabel("Connection of Pavot to a solver by a socket \nor by loading a file",SwingConstants.CENTER);
	JLabel selectSolverLabel = new JLabel("Select a solver:",SwingConstants.LEFT);
	JLabel connectionModeLabel= new JLabel("Select a connection mode:",SwingConstants.LEFT);
	JLabel socketLabel =new JLabel("Socket (host and port must be provided by the solver and already open):");
	JLabel fileLabel =new JLabel("File:");
	JLabel hostLabel= new JLabel("    Host: ");
	JLabel portLabel= new JLabel("    Port: ");
	JLabel titleLabel= new JLabel("Source selection");

	JFileChooser fileChooser=new JFileChooser();
	JButton loadFileButton=new JButton("Load");
	File fileToLoad;

	static final public int SOCKET=1;
	static final public int FILE=2;
	int dataType,solverType;
	Container mainLayout=new Container();
	/**
	 * Constructor.
	 */
	public UISolverSelection() {
		this.setUndecorated(true);
		this.setDefaultLookAndFeelDecorated(true);
		this.getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
		headerLabel.setFont(new Font("Dialog",Font.BOLD,13));
		fileChooser.setCurrentDirectory(new File("."));
		//fileChooser.setCurrentDirectory(new File(currentFile));

		JPanel mainPane=new JPanel();
		Box socketPane=new Box(BoxLayout.Y_AXIS);
		JPanel socketDataPane=new JPanel();
		JPanel hostPane=new JPanel();
		JPanel portPane=new JPanel();
		Box filePane=new Box(BoxLayout.X_AXIS);
		Box selectBorder=new Box(BoxLayout.Y_AXIS);
		Box solverBox=new Box(BoxLayout.Y_AXIS);

		this.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

		this.getContentPane().setSize(new Dimension(500,285));
		this.setSize(new Dimension (500,285));
		this.setTitle("Solver selection");

		mainPane.setAlignmentX(Component.CENTER_ALIGNMENT);
		this.getContentPane().add(mainPane);
		mainPane.setLayout(new BoxLayout(mainPane,BoxLayout.Y_AXIS));
		
		///////////////
		// HEADER

		mainPane.add(Box.createRigidArea(new Dimension(0,10)));
		headerLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
		mainPane.add(headerLabel);
		mainPane.add(Box.createRigidArea(new Dimension(0,20)));
	//	mainPane.add(new JSeparator(SwingConstants.HORIZONTAL));
	//	mainPane.add(Box.createRigidArea(new Dimension(0,10)));
		
		///////////////
		// SOLVER TYPE 
		
/*		solverBox.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		solverBox.setPreferredSize(new Dimension(450,185));
		solverBox.setMaximumSize(new Dimension(500,185));
		solverBox.setAlignmentX(Component.CENTER_ALIGNMENT);

		solverBox.add(selectSolverLabel);
		solverBox.add(Box.createRigidArea(new Dimension(0,5)));
		// CLPGUI

        solverBox.add(clpguisocketBox);
		clpguisocketBox.addActionListener(this);
		// GPROLOG
		solverBox.add(gprologsocketBox);
		gprologsocketBox.addActionListener(this);

		mainPane.add(solverBox);
		mainPane.add(Box.createRigidArea(new Dimension(0,10))); */
	
		///////////////
		// CONNECTION MODE PART

		// Border createEtchedBorder
		selectBorder.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		selectBorder.setPreferredSize(new Dimension(450,185));
		selectBorder.setMaximumSize(new Dimension(500,185));
		//selectBorder.setLayout(new BoxLayout(selectBorder,BoxLayout.Y_AXIS));
		selectBorder.setAlignmentX(Component.CENTER_ALIGNMENT);
//		selectBorder.setAlignmentY(Component.CENTER_ALIGNMENT);
		
		// SOCKET PART
		socketPane.setLocation(0,0);
		socketPane.setAlignmentX(Component.LEFT_ALIGNMENT);
		//socketPane.setBorder(BorderFactory.createLineBorder(Color.black));
		socketPane.setPreferredSize(new Dimension(450,110));
		socketPane.setMaximumSize(new Dimension(500,110));
		
	//	connectionModeLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
		selectBorder.add(connectionModeLabel);
		selectBorder.add(Box.createRigidArea(new Dimension(0,5)));
		
		// HOST & PORT
		socketBox.addActionListener(this);
		socketPane.add(socketBox);
		socketPane.add(Box.createRigidArea(new Dimension(0,5)));
//		socketLabel.setBorder(BorderFactory.createLineBorder(Color.black));
		//socketLabel.setAlignmentX(0);
		socketPane.add(hostPane);
		hostPane.setAlignmentX(0);
//		hostPane.setBorder(BorderFactory.createLineBorder(Color.black));
		hostPane.setPreferredSize(new Dimension(200,20));
		hostPane.setMaximumSize(new Dimension(300,20));
		hostPane.setLayout(new BoxLayout(hostPane,BoxLayout.X_AXIS));		
		hostLabel.setPreferredSize(new Dimension(60,20));
		hostPane.add(hostLabel);
		hostPane.add(hostField);
		socketPane.add(portPane);
		portPane.setAlignmentX(0);
//		portPane.setBorder(BorderFactory.createLineBorder(Color.black));
		portPane.setPreferredSize(new Dimension(200,20));
		portPane.setMaximumSize(new Dimension(300,20));
		portPane.setLayout(new BoxLayout(portPane,BoxLayout.X_AXIS));
		portLabel.setPreferredSize(new Dimension(60,20));
		portPane.add(portLabel);
		portPane.add(portField);
		socketPane.add(Box.createRigidArea(new Dimension(0,5)));
	/*	// CLPGUI
		socketPane.add(clpguisocketBox);
		//clpguisocketBox.setAlignmentX(0);
		clpguisocketBox.addActionListener(this);
		// GPROLOG
		socketPane.add(gprologsocketBox);
		gprologsocketBox.addActionListener(this);*/
		
		//socketPane.add(Box.createHorizontalGlue());
		selectBorder.add(socketPane);
		
		// Separation
	/*	selectBorder.add(Box.createRigidArea(new Dimension(0,10)));
		JSeparator separator=new JSeparator(SwingConstants.HORIZONTAL);
		separator.setPreferredSize(new Dimension(450,10));
		separator.setMaximumSize(new Dimension(500,10));
		separator.setAlignmentX(Component.LEFT_ALIGNMENT);
		//separator.setBorder(BorderFactory.createLineBorder(Color.black));
		selectBorder.add(separator);*/
		selectBorder.add(Box.createRigidArea(new Dimension(0,10)));

		// FILE PART
		selectBorder.add(filePane);
		filePane.setAlignmentX(Component.LEFT_ALIGNMENT);
		//filePane.setAlignmentY(Component.TOP_ALIGNMENT);
		//filePane.setLayout(new BoxLayout(filePane,BoxLayout.X_AXIS));
		filePane.setPreferredSize(new Dimension(250,20));
		filePane.setMaximumSize(new Dimension(300,20));
		//filePane.setBorder(BorderFactory.createLineBorder(Color.black));
		fileBox.addActionListener(this);
		fileChooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		loadFileButton.setPreferredSize(new Dimension(70,20));
		loadFileButton.setMaximumSize(new Dimension(70,20));
		loadFileButton.addActionListener(this);
		filePane.add(fileBox);
		filePane.add(fileLocationField);
		filePane.add(loadFileButton);
//		selectBorder.add(Box.createRigidArea(new Dimension(0,20)));

		mainPane.add(selectBorder);
		// Ok button
		ok.setAlignmentX(Component.CENTER_ALIGNMENT);
		ok.addActionListener(this);
		mainPane.add(Box.createRigidArea(new Dimension(0,20)));
		mainPane.add(ok);
		mainPane.add(Box.createRigidArea(new Dimension(0,20)));

		//
		this.getContentPane().setVisible(true);
		this.setVisible(true);
		this.show();
		

	}

	/**
	 * Action events.
	 */
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==ok){
			if(socketBox.isSelected()||fileBox.isSelected()) isfinish=true;
		}
/*		else if(e.getSource()==gprologsocketBox) {
			solverType=SolverType.GPROLOG;
			clpguisocketBox.setSelected(false);
		}
		else if(e.getSource()==clpguisocketBox) {
			solverType=SolverType.CLPGUI;
			gprologsocketBox.setSelected(false);
		}*/
		else if(e.getSource()==socketBox) {
			dataType=SOCKET;
			fileBox.setSelected(false);
		}
		else if(e.getSource()==fileBox) {
			dataType=FILE;
			socketBox.setSelected(false);
		}
		else if(e.getSource()==loadFileButton) {
			int returnVal = fileChooser.showOpenDialog(UISolverSelection.this);
			if(returnVal==JFileChooser.APPROVE_OPTION) {
				fileToLoad=fileChooser.getSelectedFile();
				fileLocationField.setText(fileToLoad.getPath());
			}
		}
	}
	/**
	 * Refreshes.
	 */
	public void refresh() {
		this.show();
	}

	/**
	 * Is the user click ok button?
	 */
	public boolean isFinish() {return isfinish;}

	/**
	 * Gets file name.
	 */
	public String getFile(){return fileLocationField.getText();}

	/**
	 * Gets port number.
	 */
	public int getPort(){return Integer.parseInt(portField.getText());}
	
	/**
	 * Gets host name.
	 */
	public String getHost() {return hostField.getText();}

	/**
	 * Gets solver type.
	 */
	public int getSolverType() {return solverType;}
	
	/**
	 * Gets data type.
	 */
	public int getDataType() {return dataType;}

	/**
	 * Gets file.
	 */
	public File getFileToLoad() {return fileToLoad;}
}
