/** 
 * 
 */
package main;

import gui.UISolverSelection;
import gui.UIManager;
import gui.ControlPlay;
import gui.PavotInternalFrame;
import gui.PavotFrame;

import viewer.*;

import parser.PropagationSolver;

import control.SocketInputSource;

import request.PropagationRequest;

import datastruct.*;

import javax.swing.JFrame;

import java.util.*;
import java.net.*;
import java.io.*;
import java.util.zip.GZIPInputStream;

import org.xml.sax.InputSource;
import org.apache.log4j.Logger;

import fr.inria.oadymppac.utils.log.LogConfigurator;

import fr.inria.oadymppac.io.PostMortemInputSource;
import fr.inria.oadymppac.parsing.gentra4cp.TraceContentHandler;

import fr.inria.oadymppac.examples.parsing.SingleProvideEventListener;
import fr.inria.oadymppac.examples.parsing.SingleControlEventListener;
import fr.inria.oadymppac.examples.parsing.SingleComplementEventListener;
import fr.inria.oadymppac.examples.parsing.SingleSolverEventListener;
import fr.inria.oadymppac.examples.parsing.SingleHeadEventListener;

import control.ThreadControl;

/**
 * Main class for the tracerGUI.
 *
 * @author Guillaume Arnaud
 * @version 0.0
 */

public class MainManager{
    static Logger logger = Logger.getLogger(MainManager.class);


    SingleHeadEventListener headListener;    
    SingleProvideEventListener providableListener, providedListener;
    SingleControlEventListener controlListener;
    SingleComplementEventListener complementListener;
    SingleSolverEventListener solverListener;
    

    
	static UISolverSelection uissmng;
	static UIManager uimng;
	static PropagationRequest pr=new PropagationRequest();
	Vector viewercsts,viewers=new Vector();
	int solverType;
	static int dataType,port=3050;
	static String host,file,hostFile;
	CLPGUIFrame3D clpguiviewer;
	CTViewer ctviewer;
    CLPGUIDomain2D clpguiDomain2D;
    CLPGUIDomain3D clpguiDomain3D;
    CLPGUISearchTree clpguiSearchTree;

    static PropagationSolver mainHandler;  
    ControlPlay controlPlay;
    static InputSource is;
    static SocketInputSource sis;
    	
	static Socket traceSocket=new Socket();
    PrintWriter pw;

	/**
	 * Constructor.
	 */
	public MainManager(){
		JFrame.setDefaultLookAndFeelDecorated(true);
		uissmng=new UISolverSelection();
		while(!uissmng.isFinish()){} // Wait the source selection
		dataType=uissmng.getDataType();
		solverType=uissmng.getSolverType();
		if(dataType==UISolverSelection.SOCKET){
			host=uissmng.getHost();
			port=uissmng.getPort();
		}
		else {
			file=uissmng.getFile();
		}
		uissmng.dispose();
		uimng=new UIManager(pr);
		while(!uimng.isFinish()){} // Wait the request selections
		viewercsts=uimng.getViewers();
		uimng.dispose();
     //   try{connection();} catch(Exception e) {}
		startParsing();
	}
	public MainManager(String[] args) {		
        if(args.length==1) {
		    dataType=UISolverSelection.FILE;
		    solverType=0;
		    file=args[0];
        }
        else if(args[0].equals("-f")) {
		    dataType=UISolverSelection.FILE;
		    solverType=1;
		    file=args[1];
        }
        else if(args[0].equals("-s")){
            host="localhost";
		    dataType=UISolverSelection.SOCKET;
            for(int i=1;i<args.length-1;i++){
                if(args[i].equals("-port")||args[i].equals("-p")) {
                    port=Integer.parseInt(args[++i]);
                    System.out.println("p="+port);
                }
                if(args[i].equals("-host")||args[i].equals("-h")) host=args[++i];                
            }
            System.out.println("[MainManager] Connection on port="+port+"; host="+host);
        }
		uimng=new UIManager(pr);
		while(!uimng.isFinish()){} // Wait the request selections
		viewercsts=uimng.getViewers();
		uimng.dispose();
      //  try{connection();} catch(Exception e) {}
		startParsing();
    	}

	/**
	 * Starts parsing.
	 */
	public void startParsing() {
		try {
            PrintStream socketOut=null;

            if(dataType==UISolverSelection.SOCKET ){
                                try {
/*                                        sis=new SocketInputSource(host, port);
                                       // sis.initialisation();
                                        Thread sisThread=new ThreadControl(sis);
                                        sisThread.start();
                                        System.out.println("[MainManager] thread start");
                                        //sis.run();  */
                                        traceSocket=new Socket();
                                        System.out.println("[MainManager] traceSocket good");
                                        traceSocket.setReceiveBufferSize(10);
                                        traceSocket.setSendBufferSize(10);
                                        //traceSocket.connect(sis.getAddress());
                                        traceSocket.connect(new InetSocketAddress(host,port));
                                        System.out.println("[MainManager] traceSocket connected");
                                       // System.out.println("[MainManager] socketbuff="+traceSocket.getSendBufferSize());
                                      //  BufferedInputStream bistream= new BufferedInputStream(traceSocket.getInputStream(),66000);
                                       // DataInputStream bistream=new DataInputStream(traceSocket.getInputStream());
                                      //  System.out.println("[MainManager] bistream.available="+bistream.available());
                                        is=new InputSource(traceSocket.getInputStream());
                                      //  is.setByteStream(bistream);
                                        //socketOut= new PrintStream(traceSocket.getOutputStream(),true);
                                      
                                }
                                catch (Exception e) {
                                System.err.println("Don't know about host.");
                                System.exit(1);
                                is=null;
                                }
                pw=new PrintWriter(new OutputStreamWriter(traceSocket.getOutputStream()));
                mainHandler=new PropagationSolver(is);
                System.out.println("[MainManager] socket initialized");
				hostFile=host;
            }
            else if (file.endsWith(".gz")) {
                                is = new InputSource(new GZIPInputStream(new FileInputStream(file)));
                                is.setSystemId(file);
			                	hostFile=file;
                                mainHandler=new PropagationSolver(is);
                        }
                        else {
                                is = new InputSource(file);
                                is.setSystemId(file);
                				hostFile=file;
                                mainHandler=new PropagationSolver(is);
                         }

                        
			DataStructManager ctmg=new DataStructManager(mainHandler,pr,viewercsts,this);
//            System.out.println("[MainManager] addDefaultListener ?");
           // mainHandler.addDefaultListener(ctmg);
            //this.init_handlers(ctmg);
//           System.out.println("[MainManager] addDefaultListener ok");

            // Initialized queried viewers
			if(((Boolean)viewercsts.elementAt(ViewerConstants.PAVOT)).booleanValue()){
				ctviewer= new CTViewer(ctmg.getPropagationTree(),solverType,dataType,hostFile,port, pr);
                viewers.addElement(ctviewer);
			}
			if(((Boolean)viewercsts.elementAt(ViewerConstants.CLPGUI)).booleanValue()){
               
               clpguiDomain2D = new CLPGUIDomain2D(ctmg.getDomains2D());
               clpguiDomain3D = new CLPGUIDomain3D(ctmg.getDomains2D(), ctmg.getDomains3D());
               clpguiSearchTree=new CLPGUISearchTree(ctmg.getSearchTree());               

               clpguiSearchTree.setHighLight(clpguiDomain3D.getHighLight());

               viewers.addElement(clpguiDomain2D);
               viewers.addElement(clpguiDomain3D);
               viewers.addElement(clpguiSearchTree);
               
            }

			// Control the trace
            controlPlay=new ControlPlay(mainHandler,dataType,pw,viewers);
            //Thread toto=new Thread(controlPlay);
            //toto.start();
   //         mainHandler.parse();

        //    while(!controlPlay.isStarted()||mainHandler.isAlive()){}
        //    System.out.println("Parsing finished");

		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
	}
	
	// Refresh fonction
	public void refresh(){
        Enumeration enu=viewers.elements();
        while(enu.hasMoreElements()){
            PavotViewer pv=(PavotViewer)enu.nextElement();
            pv.refresh();
        }
	}
	
	public static void main(String[] args){
		MainManager mng;
        LogConfigurator.configure();
        if(args.length==0) {
            mng=new MainManager();}
        else mng=new MainManager(args);
//        try{ connection();} catch(Exception exce){}
	}

    protected void init_handlers(DataStructManager ctmg) {
        System.out.println("[MainManager] init_handlers");
        
   /*     headListener = new SingleHeadEventListener();
        System.out.println("[MainManager] init_handlers 1");
        providableListener = new SingleProvideEventListener(SingleProvideEventListener.HEAD);
        System.out.println("[MainManager] init_handlers 2");
        providedListener = new SingleProvideEventListener(SingleProvideEventListener.TRACE);
        System.out.println("[MainManager] init_handlers 3");
        controlListener = new SingleControlEventListener();
        System.out.println("[MainManager] init_handlers 4");
        complementListener = new SingleComplementEventListener();
        System.out.println("[MainManager] init_handlers 5");*/
   /*     solverListener = new SingleSolverEventListener();
        System.out.println("[MainManager] init_handlers 6");*/
        
   //     mainHandler.addDefaultListener(ctmg);
     //   System.out.println("[MainManager] init_handlers 8");
  /*      mainHandler.addControlListener(controlListener);
        System.out.println("[MainManager] init_handlers 9");
        mainHandler.addHeadListener(headListener);
        System.out.println("[MainManager] init_handlers 10");
        
        mainHandler.addProvidableListener(providableListener);
        System.out.println("[MainManager] init_handlers 11");
        mainHandler.addProvidedListener(providedListener);
        System.out.println("[MainManager] init_handlers 12");
        mainHandler.addComplementListener(complementListener);
        System.out.println("[MainManager] init_handlers exit");*/
    }

    private static void connection() throws Exception{
 /*       if(dataType== UISolverSelection.SOCKET) {
        ServerSocket s = new ServerSocket(9080);
        Socket soc=new Socket();
        System.out.println("[MainManager] socket accepted?");
        soc=s.accept();
        System.out.println("[MainManager] socket accepted");
        
        sis=new SocketInputSource(host, port);
        sis.initialisation(soc);
        Thread sisThread=new ThreadControl(sis);
        sisThread.start();
        traceSocket=new Socket();
        traceSocket.connect(sis.getAddress());
        System.out.println("[MainManager] socketbuff="+traceSocket.getSendBufferSize());
        is=new InputSource(traceSocket.getInputStream());
        }*/
    }

}
